//+------------------------------------------------------------------+
//|                                            SlopeDirectionLine_v3 |
//|                                    Copyright (c) 2008, latimeria |
//+------------------------------------------------------------------+
#property copyright "Copyright (c) 2008, latimeria"

// You Need Custom Indicator named <Slope Direction Line Modified>.

//parameters
extern string  ParamExp = "<<< Indicator Parameters >>>";
extern bool    UseSimpleJudgement = false;  // if <true> Trend is judged by just 2 bars(It means signal appears "1 bar ealier", but may not be "reliable"). if <false> use 5bars
extern int     period=80;  // PERIOD
extern int     method=3;   // MODE_SMA
extern int     price=0;    // PRICE_CLOSE

extern string  MAFilterExp = "<<< MA Filter Settings >>>";
extern bool    UseMAFilter = true;
extern int     MA_Period=200;
extern string  MAFilter_note = "1=SMA, 2=EMA, 3=SMMA, 4=LWMA";
extern int     MA_Method=1;

//TradeSwitch
extern string  TradeSwitchExp = "<<< Trade Switch >>>";
extern bool    Buy = true ;
extern bool    Sell = true ;

//PositionSizing
extern string  PSExp = "<<< Position Sizing >>>";
extern double  FixLot=0.1; // if you don't use PS, this lot size is used.
extern bool    PositionSizing = true ;
extern double  PS_RiskRate = 0.8;
extern int     ATR_Period=30;

//Initial Stop Loss
extern string  InitialStopLossExp = "<<< Initial Stop Loss >>>";
extern string  AboutInitialStopLoss = "---  You can change Initial StopLoss Method ---";
extern string  InitialStop_note = "0=Fake(No_SL),  1=ATR_Multiple_SL,  2=FixPips_SL";
extern int     InitialStop_Method = 1;
extern double  InitialStopATR = 1.7;
extern int     InitialStopPips = 200;

//Trailing Stop
extern string  TrailMethodExp = "<<< Trailing Stop Method >>>";
extern string  AboutTrail_Method = "--- You can change Trailing Method ---";
extern string  Trail_Method_note = "0=Trail_OFF, 1=ATR_Mode, 2=FixPips_Mode, 3=Profit_Mode";
extern int     TRAIL_MODE = 1.2;

extern string  AboutTrail_Method1 = "--- 1. You can change Trailing ATR Multiple ---";
extern double  Trail_ATR = 2.5;
extern string  AboutTrail_Method2 = "--- 2. You can change Trailing Pips ---";
extern int     Trail_Pips = 200;
extern string  AboutTrail_Method3 = "--- 3. You can change Trailing Profit to Reserve ---";
extern double  Profit_to_Reserve = 0.5;

//Miscellaneous Settings
extern string  MisExp = "<<< Miscellaneous Settings >>>";
extern int     Slippage = 3;
extern bool    UseMicrolot = false ;
extern bool    ShowCurrentEntryPrice = true ;
extern bool    Alert_On = true ;
extern bool    Sound_On = true ;

//magic number
int MAGIC = 7777777;

//EA name
string  EANAME="SlopeDirectionLine_v3";
string  EASHORTNAME="SlopeDirLine_v3";


//+------------------------------------------------------------------+
//| start                                                            |
//+------------------------------------------------------------------+
int start()
{
	//Get Current Position
   int pos = CalculateCurrentOrders();

	//Draw Current Entry Price
   if(ShowCurrentEntryPrice)
   {
      ObjectDelete("CurrentEntry"); 
      if(pos != 0)
      {
         double CurEntryPrice = GetCurrentEntryPrice();
         DrawCurEntryPrice("CurrentEntry", Time[0], CurEntryPrice , Red);
      }
   }
   
	//Trade Only Bar Opening
   if(Volume[0]>1 || IsTradeAllowed()==false) return(0);
   
   // Trailing Stop
   if(TRAIL_MODE>3 || TRAIL_MODE<0) TRAIL_MODE = 1; // error correction
   if( (pos > 0 || pos < 0) && TRAIL_MODE != 0 ) MultiModeTrailingStop();
      
	//Entry_Logic
   int TRADE_DIRECTON = 0;

   double TrendDir_0 = iCustom(NULL, 0, "Slope Direction Line Modified", period, method, price, 3, 0); // Trend Direction of Current Bar
   double TrendDir_1 = iCustom(NULL, 0, "Slope Direction Line Modified", period, method, price, 3, 1); // Trend Direction of 1 Previous Bar
   double TrendDir_2 = iCustom(NULL, 0, "Slope Direction Line Modified", period, method, price, 3, 2); // Trend Direction of 2 Previous Bar
   double TrendDir_3 = iCustom(NULL, 0, "Slope Direction Line Modified", period, method, price, 3, 3); // Trend Direction of 3 Previous Bar
   double TrendDir_4 = iCustom(NULL, 0, "Slope Direction Line Modified", period, method, price, 3, 4); // Trend Direction of 4 Previous Bar

   Comment("TrendDir[0]= ",TrendDir_0,"TrendDir[1]= ",TrendDir_1," TrendDir[2]= ",TrendDir_2," TrendDir[3]= ",TrendDir_3," TrendDir[4]= ",TrendDir_4);

	//Judge SlopeDirection Line (5bars version)
   if(TrendDir_0 > 0 && TrendDir_1 > 0 && TrendDir_2 > 0 && TrendDir_3 < 0 && TrendDir_4 < 0) TRADE_DIRECTON = 1;
   if(TrendDir_0 < 0 && TrendDir_1 < 0 && TrendDir_2 < 0 && TrendDir_3 > 0 && TrendDir_4 > 0) TRADE_DIRECTON = 2;

	//Judge SlopeDirection Line (2bars version)
   if(UseSimpleJudgement)
   {
      if(TrendDir_1 > 0 && TrendDir_2 < 0) TRADE_DIRECTON = 1;
      if(TrendDir_1 < 0 && TrendDir_2 > 0) TRADE_DIRECTON = 2;
   }

   //Signal Reverse Exit
   if(pos > 0) if(TRADE_DIRECTON == 2) ClosePositions(); //Close Buy
   if(pos < 0) if(TRADE_DIRECTON == 1) ClosePositions(); //Close Sell

	//MA Filter
   int MA_DIRECTION = 0;
   if(UseMAFilter)
   {
      if(MA_Method>4 || MA_Method<1) MA_Method = 1; // error correction
      switch(MA_Method)
      {
         case 1: string MA_TYPE = "MODE_SMA"; break; 
         case 2: MA_TYPE = "MODE_EMA"; break; 
         case 3: MA_TYPE = "MODE_SMMA"; break; 
         case 4: MA_TYPE = "MODE_LWMA"; break; 
      }
      double MA_1 = iMA(NULL,0,MA_Period,0,MA_TYPE,PRICE_CLOSE,1);
      double MA_2 = iMA(NULL,0,MA_Period,0,MA_TYPE,PRICE_CLOSE,2);
      if(MA_1 > MA_2) MA_DIRECTION = 1; else MA_DIRECTION = 2;
      if(TRADE_DIRECTON != MA_DIRECTION) TRADE_DIRECTON = 0;
   }
      
   //Buy
   if(pos <= 0)
   {
      if(TRADE_DIRECTON == 1)
      {
         if(Buy) BuyOrder();
      }
   }

   // Sell
   if(pos >= 0)
   {
      if(TRADE_DIRECTON == 2)
      {
         if(Sell) SellOrder();
      }
   }
   return(0);
}
// end of Start Function


//+------------------------------------------------------------------+
//| ClosePositions                                                   |
//+------------------------------------------------------------------+
void ClosePositions()
{
   //Total Positions
   int total = OrdersTotal();
   if (total > 0)
   {
      for (int i = total - 1; i >=0; i--)
      {
         //Select Position
         bool selected = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if(selected && OrderMagicNumber() == MAGIC && OrderSymbol() == Symbol())
         {
            //Get Position Type
            int type = OrderType();
            
            bool success = false;
            
            switch (type)
            {
               case OP_BUY:
                  double bid = MarketInfo(OrderSymbol(), MODE_BID);
                  success = OrderClose(OrderTicket(),OrderLots(), bid, 3, CLR_NONE);
                  if(Alert_On) Alert(EASHORTNAME,"_ClosePosition ", Symbol(), " at ", Bid," Lots ",OrderLots()); 
                  if(Sound_On) PlaySound("alert2.wav");
                  break;
               case OP_SELL:
                  double ask = MarketInfo(OrderSymbol(), MODE_ASK);
                  success = OrderClose(OrderTicket(),OrderLots(), ask, 3, CLR_NONE);
                  if(Alert_On) Alert(EASHORTNAME,"_ClosePosition ", Symbol(), " at ", Ask," Lots ",OrderLots());      
                  if(Sound_On) PlaySound("alert2.wav");
                  break;
               case OP_BUYSTOP:
               case OP_BUYLIMIT:
               case OP_SELLSTOP:
               case OP_SELLLIMIT:
                  success = OrderDelete(OrderTicket());
                  break;
            }
            
            if (!success)
            {
               Print("Error code = " + GetLastError());
            }
         }
      }
   }
} // end of ClosePositions Function

//+------------------------------------------------------------------+
//| Culculate Current Open Position                                  |
//+------------------------------------------------------------------+
int CalculateCurrentOrders()
{
   //Open Positionsi+:Buy -:Sellj
   int i;
   int pos=0;

   // Buy Position
   int pos_buy=0;
   for(i=0; i<OrdersTotal(); i++)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES) == false) break;
      if(OrderSymbol() == Symbol() && OrderMagicNumber() == MAGIC)
      {
         if(OrderType() == OP_BUY) pos_buy++ ;
      }
   }

   //Sell Position
   int pos_sell=0;
   for(i=0; i<OrdersTotal(); i++)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES) == false) break;
      if(OrderSymbol() == Symbol() && OrderMagicNumber() == MAGIC)
      {
         if(OrderType() == OP_SELL) pos_sell--;
      }
   }

   //Culculate pos
   if(pos_buy>0) pos = pos_buy;
   if(pos_sell<0) pos = pos_sell;
   if(pos_sell == 0 && pos_buy == 0) pos = 0;

   return(pos);
} // end of CalculateCurrentOrders

//+------------------------------------------------------------------+
//| Buy Order                                                        |
//+------------------------------------------------------------------+
void BuyOrder()
{   
   double lot = PositionSizing();
   double InitialStop = Ask - InitialStop();
   if(InitialStop_Method == 0) InitialStop = 0;

   double Minlot = 0.1; if(UseMicrolot) Minlot = 0.01; if(lot < Minlot) return(0);
   OrderSend(Symbol(), OP_BUY, lot, Ask, Slippage, InitialStop, 0, EASHORTNAME+"_"+Symbol()+"_B", MAGIC, 0, Green);
   if(Alert_On) Alert(EASHORTNAME, "_Buy ", Symbol(), " at ", Ask," Lots ",lot);
   if(Sound_On) PlaySound("news.wav");      
}

//+------------------------------------------------------------------+
//| Sell Order                                                       |
//+------------------------------------------------------------------+
void SellOrder()
{
   double lot = PositionSizing();
   double InitialStop = InitialStop() + Bid;
   if(InitialStop_Method == 0) InitialStop = 0;

   double Minlot = 0.1; if(UseMicrolot) Minlot = 0.01; if(lot < Minlot) return(0);
   OrderSend(Symbol(), OP_SELL, lot, Bid, Slippage, InitialStop, 0, EASHORTNAME+"_"+Symbol()+"_S", MAGIC, 0, Red);
   if(Alert_On) Alert(EASHORTNAME, "_Sell ", Symbol(), " at ", Bid," Lots ",lot);
   if(Sound_On) PlaySound("news.wav");      
}

//+------------------------------------------------------------------+
//| Initial Stop                                                     |
//+------------------------------------------------------------------+
double InitialStop()
{
   double InitStop = 0;

   if(InitialStop_Method>2 || InitialStop_Method<0) InitialStop_Method = 1; // error correction
   if(InitialStop_Method == 1) InitStop = iATR(NULL,0,ATR_Period,1) * InitialStopATR ;
   if(InitialStop_Method == 2) InitStop = InitialStopPips ;
   return(InitStop);
}

//+------------------------------------------------------------------+
//| Position_Sizing                                                  |
//+------------------------------------------------------------------+
double PositionSizing()
{
   double lot = FixLot;
   
   //PositionSizing
   double StopLoss = InitialStop() ;
   if(InitialStop_Method == 0) StopLoss = iATR(NULL,0,ATR_Period,1) * InitialStopATR ;

   if(PositionSizing)
   {
      double RiskAmount = AccountFreeMargin() * (PS_RiskRate/100) ;
      int SLpips = StopLoss/Point ;
      double PT = profit_unit(); // call function
      lot = RiskAmount/(PT * SLpips) ;
   }

   int lotDigit = 1 ; if(UseMicrolot) lotDigit = 2;
   lot = NormalizeDouble(lot,lotDigit) ;

   return(lot);
}

//+------------------------------------------------------------------+
//| profit_unit                                                      |
//+------------------------------------------------------------------+
double profit_unit()
{
    double lot_size    =MarketInfo(Symbol(),MODE_LOTSIZE); //
    string base_currecy=StringSubstr(Symbol(),0,3);
    int    symbol_len  =StringLen(Symbol());
    string term_currecy="USD";
    if(symbol_len==6)
        term_currecy=StringSubstr(Symbol(),3,3);
    string term_pair =term_currecy+AccountCurrency();
    string xterm_pair=AccountCurrency()+term_currecy;
    string base_pair =base_currecy+AccountCurrency();
    double term_unit =1.0;
    if(base_currecy==AccountCurrency())
    { 
        term_unit=1.0/Bid;
    }
    else if(term_currecy!=AccountCurrency())
    {
        term_unit=iClose(term_pair,0,0);
        if(term_unit<=0)
        {
            term_unit=iClose(xterm_pair,0,0);
            if(term_unit<=0)
            {
                term_unit=iClose(base_pair,0,0);
            }
            else
            {
               term_unit=1.0/term_unit;
            }
        }
    }
    return(lot_size*Point*term_unit); // returns Profit/Loss per 1.0 lot * 1pip by your accout currency.
}

//+------------------------------------------------------------------+
//| GetCurrentEntryPrice                                             |
//+------------------------------------------------------------------+
double GetCurrentEntryPrice()
{
   int i; double CurEntryPrice;

   for(i=0; i<OrdersTotal(); i++)
   {
      bool selected = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(selected && OrderMagicNumber() == MAGIC && OrderSymbol() == Symbol())
      {
         CurEntryPrice = OrderOpenPrice();
      }
   }
return(CurEntryPrice);
}

//+------------------------------------------------------------------+
//| DrawCurEntryPrice                                                |
//+------------------------------------------------------------------+
void DrawCurEntryPrice(string name, datetime TIME, double PRICE, color COLOR)
  {
   if(CalculateCurrentOrders() > 0) COLOR = Lime;
   if(CalculateCurrentOrders() < 0) COLOR = Red;

   if(ObjectFind(name) == -1)
     {
       ObjectCreate(name, OBJ_ARROW, 0, TIME, PRICE);
       ObjectSet(name, OBJPROP_COLOR, COLOR);
       ObjectSet(name, OBJPROP_WIDTH, 1);
       ObjectSet(name, OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
     }
   else
     {
       ObjectSet(name, OBJPROP_TIME1, TIME);
       ObjectSet(name, OBJPROP_PRICE1, PRICE);
       ObjectSet(name, OBJPROP_COLOR, COLOR);
       ObjectSet(name, OBJPROP_WIDTH, 1);
       ObjectSet(name, OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
     } 
  }

//+------------------------------------------------------------------+
//| MultiModeTrailingStop                                            |  TRAIL_MODE   0=Trail_OFF, 1=ATR_Mode, 2=FixPips_Mode, 3=Profit_Mode 
//+------------------------------------------------------------------+
void MultiModeTrailingStop()
{
   int pos,i;
   double STOP, CurrentSL, STOP_HABA, Profit;
   bool selected;

   pos = CalculateCurrentOrders();

   // Get Current Stop Loss
   CurrentSL = CheckCurrentStop();

   if(TRAIL_MODE == 1) STOP_HABA = iATR(NULL,0,ATR_Period,1)*Trail_ATR ;
   if(TRAIL_MODE == 2) STOP_HABA = Trail_Pips * Point ;

if(pos > 0) //Buy Position ------------------------------------------------------------------------------
{
   if( (TRAIL_MODE == 1 || TRAIL_MODE == 2) && Close[1] - STOP_HABA > CurrentSL) // if ATR or Fixpips Mode
   {
      STOP = Close[1] - STOP_HABA ;
   
      // Modify Stop Loss (Buy --- ATR/FIX)
      for(i=0; i<OrdersTotal(); i++)
      {
         selected = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if(selected && OrderMagicNumber() == MAGIC && OrderSymbol() == Symbol() && OrderType() == OP_BUY)
         {
            OrderModify(OrderTicket(),OrderOpenPrice(),STOP,0,0,Violet);
         }
      }
   return(0);
   }

   if(TRAIL_MODE == 3) // if ProfitMode
   {
      Profit = Bid - CurrentSL; // Culculate Current Profit by pips
      STOP = Bid - (Profit * Profit_to_Reserve);
   
      // Modify Stop Loss (Buy --- Profit)
      for(i=0; i<OrdersTotal(); i++)
      {
         selected = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if(selected && OrderMagicNumber() == MAGIC && OrderSymbol() == Symbol() && OrderType() == OP_BUY)
         {
            OrderModify(OrderTicket(),OrderOpenPrice(),STOP,0,0,Violet);
         }
      }
   return(0);
   }

} // end of Buy Trailing --------------------------------------------------------------------------------

if(pos < 0) //Sell Position
{
   // Modify Stop Loss
   if( (TRAIL_MODE == 1 || TRAIL_MODE == 2) && Close[1] + STOP_HABA < CurrentSL) // if ATR or Fixpips Mode
   {
      STOP = Close[1] + STOP_HABA ;

      // Modify Stop Loss (Sell --- ATR/FIX)
      for(i=0; i<OrdersTotal(); i++)
      {
         selected = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if(selected && OrderMagicNumber() == MAGIC && OrderSymbol() == Symbol() && OrderType() == OP_SELL)
         {
            OrderModify(OrderTicket(), OrderOpenPrice(),STOP,0,0,Yellow);
         }
      }
   return(0);
   }

   if(TRAIL_MODE == 3) // if ProfitMode
   {
      // Modify Stop Loss
      Profit = CurrentSL - Ask ; // Get Current Stop Loss
      STOP = Ask + (Profit * Profit_to_Reserve);

      // Modify Stop Loss (Sell --- Profit)
      for(i=0; i<OrdersTotal(); i++)
      {
         selected = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if(selected && OrderMagicNumber() == MAGIC && OrderSymbol() == Symbol() && OrderType() == OP_SELL)
         {
            OrderModify(OrderTicket(), OrderOpenPrice(),STOP,0,0,Yellow);
         }
      }
   }

} // end of Sell Trailing --------------------------------------------------------------------------------

} // end of MultiModeTrailing()


//+------------------------------------------------------------------+
//| Get Current StopLoss                                             |
//+------------------------------------------------------------------+
double CheckCurrentStop()
{
   int pos,i;
   double Profit, STOP, CurrentSL;
   bool selected;
   
   pos = CalculateCurrentOrders();

   if(pos>0) // Buy
   {
      CurrentSL = 0;
      // Get Current StopLoss
      for(i=0; i<OrdersTotal(); i++)
      {
         selected = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if(selected && OrderMagicNumber() == MAGIC && OrderSymbol() == Symbol() && OrderType() == OP_BUY)
         {
            if(OrderStopLoss() > CurrentSL) CurrentSL = OrderStopLoss();
         }
      }
   return(CurrentSL);
   }
   
   if(pos<0) // Sell
   {
      CurrentSL = 10000;
      // Get Current StopLoss
      for(i=0; i<OrdersTotal(); i++)
      {
         selected = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if(selected && OrderMagicNumber() == MAGIC && OrderSymbol() == Symbol() && OrderType() == OP_SELL)
         {
            if(OrderStopLoss() < CurrentSL) CurrentSL = OrderStopLoss();
         }
      }
   return(CurrentSL);
   }   
} // end of CheckCurrentStop

